module Metasm
module GtkGui
class Debugger
	def keypress(ev)
		$BPADDR = 0x401033
		@wd = WinDbg.new('whotkey.exe')
		class << @wd
			def handler_newthread(pid, tid, info)
				super
				puts "breakpoint set..."
				ctx = get_context(pid, tid)
				ctx[:dr0] = $BPADDR
				ctx[:dr6] = 0
				ctx[:dr7] = 1
				WinAPI::DBG_CONTINUE
			end

			def handler_exception(pid, tid, info)
				if info.code == WinAPI::STATUS_SINGLE_STEP and
				get_context(pid, tid)[:eip] == $BPADDR
					ebp = get_context(pid, tid)[:ebp]
					msg = @mem[pid][ebp-0x18, 4].unpack('L')
					key = @mem[pid][ebp-0x14, 4].unpack('L')
					puts "msg #{Expression[msg]} key #{Expression[key]} #{Expression[get_context(pid, tid)[:eax]]}"
					WinAPI::DBG_CONTINUE
				else
					super
				end
			end
		end

		de = @wd.debugevent_alloc
		Gtk.idle_add {
			@wd.debugloop_step(de) if WinAPI.waitfordebugevent(de, 0)
			true
		}
	end
end
end
end
